Subject: Re: [DNA] No FastRA unless Landmark? (draft-pentland-dna-protocol-00)

From: Sathya Narayanan <[email-masked]>
Date: Wed, 01 Jun 2005 09:24:17 -0400

Greg -

> 
> In section 5.1.5, the proposal says:
> 
> "If the source address of the Router Solicitation is the
>  Unspecified Address or if it does not contain a landmark option,
>  then the router builds a CompleteRA and schedules it for multicast
>  transmission as per RFC 2461.  The interface MUST remain in the
>  UnicastSender state."
> 
> Is it intended that hosts which don't divulge their previously
> attached prefix in a RS landmark option aren't provided with FastRA service?

No. 

Looks like there are two reasons why a host will not include a landmark option (I thought about only the first):
1) Host is a non-DNA host
2) Host doesn't want to divulge their landmark

The text in the draft is targetted at the first case, i.e. if the RS message doesn't have a landmark option it is a non-DNA host. The only way to help out the host is by sending a CompleteRA because the router doesn't not know what question to answer. For a non-DNA host, a completeRA will be only partially helpful, if it hasn't moved link and sees its current prefix in the completeRA in a PIO - because it can neither recognize the completeRA bit nor the DNAO. Sending too-many unicast CompleteRA with the hope that it is useful for the host is not good for link-utilization and hence the recommendation.

Now, I think, the same logic applies for the second case too, even though a DNA-host could receive better benefit from the CompleteRA. The router has no-way of knowing whether the sender is a dna-host or not.

So, the question is do you (WG) think that it makes sense to respond with a CompleteRA message every time a RS message without a landmark arrives. IMHO, no.

regards,
Sathya

---

From: Syam Madanapalli <[email-masked]>
Date: Wed, 01 Jun 2005 20:23:10 +0530

Hi Sathya

> So, the question is do you (WG) think that it makes sense to respond with a CompleteRA message every time a RS message without a landmark arrives. IMHO, no.

I think it may make sense to send a completeRA every time an RS is received. 
For example if I prefer implementing Link Identifier based approach instead of 
Landmark based approach, the complete RA is useful. 

The FastRA method should have been a seperate draft, unless we are going to
have a single DNA solution.

---

From: James Kempf <[email-masked]>
Date: Wed, 01 Jun 2005 14:04:09 -0700

> have a single DNA solution.

Right, so what is planned on this? Is there going to be a discussion about
whether more than one solution is needed? Whether people want more than one?
Currently, I believe we have two.

                    jak

---

From: Erik Nordmark <[email-masked]>
Date: Wed, 01 Jun 2005 16:50:33 -0700

> Currently, I believe we have two.

I assume the desired result is that we end up with one overall solution 
to implement in hosts and routers, and not N different schemes, because 
that doesn't help with interoperability.

However, in the overall solution I think the hosts this needs to have 
the ability to handle unmodified routers (for which we have CPL as the 
core piece on the table) and do something more efficient ("the 
solution") when the routers do the new DNA thing.

   Erik

---

From: Greg Daley <[email-masked]>
Date: Thu, 02 Jun 2005 11:02:25 +1000

Hi Sathya,

> Greg -
[cut]
> The text in the draft is targetted at the first case, i.e. if the RS message
 > doesn't have a landmark option it is a non-DNA host. The only way to 
help out
 > the host is by sending a CompleteRA because the router doesn't not 
know what
 > question to answer. For a non-DNA host, a completeRA will be only 
partially helpful,
 > if it hasn't moved link and sees its current prefix in the completeRA 
in a PIO -
 > because it can neither recognize the completeRA bit nor the DNAO. 
Sending too-many
 > unicast CompleteRA with the hope that it is useful for the host is 
not good for
 > link-utilization and hence the recommendation.

The question wasn't about completeRA, it was about FastRA.

Non-DNA hosts aren't going to benefit from the RA's DNA content,
but they are going to benefit from a fast response.

So there really shouldn't be a problem with supplying fast
response so long as the solicitation is compliant with
the algorithm for delivering an RA quickly (has a source address,
and can create, or already has an NCE).

(Now visiting the CompleteRA without Landmark solicitation issue).
> Now, I think, the same logic applies for the second case too, even though a DNA-host
 > could receive better benefit from the CompleteRA. The router has 
no-way of knowing
 > whether the sender is a dna-host or not.

This is the essential point for completeRA without landmarks.

Why doesn't it know? because without the landmark you can't tell that
it's DNA capable.

Fortunately, there are plenty of bits left in the RS header (32)
which could be used to identify a DNA solicitation without divulging
the last attached prefix of the host in a landmark option.

Please be aware that I personally consider location privacy to be a
'big issue'.

Greg

---

From: Greg Daley <[email-masked]>
Date: Thu, 02 Jun 2005 11:10:06 +1000

Hi James,

James Kempf wrote:
>>The FastRA method should have been a seperate draft, unless we are going
> 
> to
> 

I believed that at the last IETF the rough consensus was that
there will eventually be one solution, which must be selected
by the WG (with expertise from the DT to assist).

There's only one solutions document on the charter of the WG.

So I guess I don't see the need for a separate 'Fast RA'
document at the moment.

That's not to say that draft-pentland-dna-protocol is the
complete solution just because Hash Based FastRA is defined there
(for example).

The Fast RA scheme is sound regardless of whether landmarks or
completeRA are used.

Greg

---

From: Syam Madanapalli <[email-masked]>
Date: Fri, 03 Jun 2005 10:30:47 +0530

Hi Greg,

> by the WG (with expertise from the DT to assist).

This is the best way to goforward and avoid to have multiple solutions
at the same time, which causes interoperability problems and burden on
implementers.

> So I guess I don't see the need for a separate 'Fast RA'

This is true, as long as we have a single solution. I hope
we will not rework in the future to come up with a new
solution for DNA where we would also require the FastRA.

> complete solution just because Hash Based FastRA is defined there

I agree with you and WG will decide. But I see two proposals
1. Landmark based and 2. Linkid based, both are from Design
team. I think somebody from the design team can put the pros
and cons of each method on WG mailing list, so that people
will have some idea before the WG meeting in Paris

> The Fast RA scheme is sound regardless of whether landmarks or

Indeed.

And the idea of limiting the no. of FASTRAs to FASTRA_THRESHOLD (3)
is a good addition, hoping that no other adverse implications

---

From: Greg Daley <[email-masked]>
Date: Fri, 03 Jun 2005 15:18:49 +1000

Hi Syam,

Syam Madanapalli wrote:
[cut]
> will have some idea before the WG meeting in Paris

Please be aware that the draft-pentland-dna-protocol's link
identification is not just a landmark based scheme, but also
provides a LinkID in the form of CompleteRA.

Since there's such good discussion going on, I think
it would be good to get the points presented on-list
to decide well before the meeting.

There may be issues raised beforehand which need to be resolved,
but we can make consensus calls (with appropriate durations
and prior warnings) on-list.

Only the issues which can't be resolved would have to wait
until the meeting.

Does that sound reasonable?

It would require that people are familiar with solutions to the
point where they could make a decision.

So anyone who hasn't been reading the solutions proposals,
please find some time to do so soon.

Greg